<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!-- NewPage -->
<html lang="en">
<head>
<!-- Generated by javadoc (1.8.0_202) on Sat Apr 27 15:39:28 CEST 2019 -->
<title>FBManagedConnection (Jaybird API)</title>
<meta name="date" content="2019-04-27">
<link rel="stylesheet" type="text/css" href="../../../stylesheet.css" title="Style">
<script type="text/javascript" src="../../../script.js"></script>
</head>
<body>
<script type="text/javascript"><!--
    try {
        if (location.href.indexOf('is-external=true') == -1) {
            parent.document.title="FBManagedConnection (Jaybird API)";
        }
    }
    catch(err) {
    }
//-->
var methods = {"i0":10,"i1":10,"i2":10,"i3":10,"i4":10,"i5":10,"i6":10,"i7":10,"i8":10,"i9":10,"i10":10,"i11":10,"i12":10,"i13":10,"i14":10,"i15":10,"i16":10,"i17":10,"i18":10,"i19":10,"i20":10,"i21":10,"i22":10,"i23":10,"i24":10,"i25":10,"i26":10,"i27":10,"i28":10,"i29":10,"i30":10,"i31":10,"i32":10,"i33":10,"i34":10,"i35":10,"i36":10,"i37":10,"i38":10,"i39":10,"i40":10,"i41":10,"i42":10,"i43":10};
var tabs = {65535:["t0","All Methods"],2:["t2","Instance Methods"],8:["t4","Concrete Methods"]};
var altColor = "altColor";
var rowColor = "rowColor";
var tableTab = "tableTab";
var activeTableTab = "activeTableTab";
</script>
<noscript>
<div>JavaScript is disabled on your browser.</div>
</noscript>
<!-- ========= START OF TOP NAVBAR ======= -->
<div class="topNav"><a name="navbar.top">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.top" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.top.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/firebirdsql/jca/FBLocalTransaction.FBLocalXid.html" title="class in org.firebirdsql.jca"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../org/firebirdsql/jca/FBManagedConnectionFactory.html" title="class in org.firebirdsql.jca"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/firebirdsql/jca/FBManagedConnection.html" target="_top">Frames</a></li>
<li><a href="FBManagedConnection.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_top">
<li><a href="../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_top");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.top">
<!--   -->
</a></div>
<!-- ========= END OF TOP NAVBAR ========= -->
<!-- ======== START OF CLASS DATA ======== -->
<div class="header">
<div class="subTitle">org.firebirdsql.jca</div>
<h2 title="Class FBManagedConnection" class="title">Class FBManagedConnection</h2>
</div>
<div class="contentContainer">
<ul class="inheritance">
<li><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">java.lang.Object</a></li>
<li>
<ul class="inheritance">
<li>org.firebirdsql.jca.FBManagedConnection</li>
</ul>
</li>
</ul>
<div class="description">
<ul class="blockList">
<li class="blockList">
<dl>
<dt>All Implemented Interfaces:</dt>
<dd>javax.resource.spi.ManagedConnection, <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a>, <a href="../../../org/firebirdsql/gds/ng/listeners/ExceptionListener.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListener</a>, <a href="../../../org/firebirdsql/jdbc/Synchronizable.html" title="interface in org.firebirdsql.jdbc">Synchronizable</a></dd>
</dl>
<hr>
<br>
<pre>public class <span class="typeNameLabel">FBManagedConnection</span>
extends <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>
implements javax.resource.spi.ManagedConnection, <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a>, <a href="../../../org/firebirdsql/gds/ng/listeners/ExceptionListener.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListener</a>, <a href="../../../org/firebirdsql/jdbc/Synchronizable.html" title="interface in org.firebirdsql.jdbc">Synchronizable</a></pre>
<div class="block">The class <code>FBManagedConnection</code> implements both the
 ManagedConnection and XAResource interfaces.</div>
<dl>
<dt><span class="simpleTagLabel">Version:</span></dt>
<dd>1.0</dd>
<dt><span class="simpleTagLabel">Author:</span></dt>
<dd><a href="mailto:d_jencks@users.sourceforge.net">David Jencks</a>, <a href="mailto:mrotteveel@users.sourceforge.net">Mark Rotteveel</a></dd>
</dl>
</li>
</ul>
</div>
<div class="summary">
<ul class="blockList">
<li class="blockList">
<!-- =========== FIELD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.summary">
<!--   -->
</a>
<h3>Field Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Field Summary table, listing fields, and an explanation">
<caption><span>Fields</span><span class="tabEnd">&nbsp;</span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Field and Description</th>
</tr>
<tr class="altColor">
<td class="colFirst"><code>static <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#ERROR_NO_CHARSET">ERROR_NO_CHARSET</a></span></code>&nbsp;</td>
</tr>
<tr class="rowColor">
<td class="colFirst"><code>static <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#WARNING_NO_CHARSET">WARNING_NO_CHARSET</a></span></code>&nbsp;</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="fields.inherited.from.class.javax.transaction.xa.XAResource">
<!--   -->
</a>
<h3>Fields inherited from interface&nbsp;javax.transaction.xa.<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a></h3>
<code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#TMENDRSCAN" title="class or interface in javax.transaction.xa">TMENDRSCAN</a>, <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#TMFAIL" title="class or interface in javax.transaction.xa">TMFAIL</a>, <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#TMJOIN" title="class or interface in javax.transaction.xa">TMJOIN</a>, <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#TMNOFLAGS" title="class or interface in javax.transaction.xa">TMNOFLAGS</a>, <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#TMONEPHASE" title="class or interface in javax.transaction.xa">TMONEPHASE</a>, <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#TMRESUME" title="class or interface in javax.transaction.xa">TMRESUME</a>, <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#TMSTARTRSCAN" title="class or interface in javax.transaction.xa">TMSTARTRSCAN</a>, <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#TMSUCCESS" title="class or interface in javax.transaction.xa">TMSUCCESS</a>, <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#TMSUSPEND" title="class or interface in javax.transaction.xa">TMSUSPEND</a>, <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#XA_OK" title="class or interface in javax.transaction.xa">XA_OK</a>, <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#XA_RDONLY" title="class or interface in javax.transaction.xa">XA_RDONLY</a></code></li>
</ul>
</li>
</ul>
<!-- ========== METHOD SUMMARY =========== -->
<ul class="blockList">
<li class="blockList"><a name="method.summary">
<!--   -->
</a>
<h3>Method Summary</h3>
<table class="memberSummary" border="0" cellpadding="3" cellspacing="0" summary="Method Summary table, listing methods, and an explanation">
<caption><span id="t0" class="activeTableTab"><span>All Methods</span><span class="tabEnd">&nbsp;</span></span><span id="t2" class="tableTab"><span><a href="javascript:show(2);">Instance Methods</a></span><span class="tabEnd">&nbsp;</span></span><span id="t4" class="tableTab"><span><a href="javascript:show(8);">Concrete Methods</a></span><span class="tabEnd">&nbsp;</span></span></caption>
<tr>
<th class="colFirst" scope="col">Modifier and Type</th>
<th class="colLast" scope="col">Method and Description</th>
</tr>
<tr id="i0" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#addConnectionEventListener-javax.resource.spi.ConnectionEventListener-">addConnectionEventListener</a></span>(javax.resource.spi.ConnectionEventListener&nbsp;listener)</code>
<div class="block">Add an <code>ConnectionEventListener</code> listener.</div>
</td>
</tr>
<tr id="i1" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#associateConnection-java.lang.Object-">associateConnection</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;connection)</code>
<div class="block">Used by the container to change the association of an application-level
 connection handle with a ManagedConneciton instance.</div>
</td>
</tr>
<tr id="i2" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#cleanup--">cleanup</a></span>()</code>
<div class="block">Application server calls this method to force any cleanup on the
 <code>ManagedConnection</code> instance.</div>
</td>
</tr>
<tr id="i3" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#close-org.firebirdsql.jdbc.FBConnection-">close</a></span>(<a href="../../../org/firebirdsql/jdbc/FBConnection.html" title="class in org.firebirdsql.jdbc">FBConnection</a>&nbsp;c)</code>
<div class="block">Close this connection with regards to a wrapping
 <code>AbstractConnection</code>.</div>
</td>
</tr>
<tr id="i4" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#commit-javax.transaction.xa.Xid-boolean-">commit</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;id,
      boolean&nbsp;onePhase)</code>
<div class="block">Commits a transaction.</div>
</td>
</tr>
<tr id="i5" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#destroy--">destroy</a></span>()</code>
<div class="block">Destroys the physical connection to the underlying resource manager.</div>
</td>
</tr>
<tr id="i6" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#end-javax.transaction.xa.Xid-int-">end</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;id,
   int&nbsp;flags)</code>
<div class="block">Dissociates a resource from a global transaction.</div>
</td>
</tr>
<tr id="i7" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#errorOccurred-java.lang.Object-java.sql.SQLException-">errorOccurred</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;source,
             <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a>&nbsp;ex)</code>
<div class="block">Notify about a SQLException</div>
</td>
</tr>
<tr id="i8" class="altColor">
<td class="colFirst"><code>protected <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#findSingleXid-javax.transaction.xa.Xid-">findSingleXid</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;externalXid)</code>
<div class="block">Obtain a single prepared transaction branch from a resource manager, based on a Xid</div>
</td>
</tr>
<tr id="i9" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#forget-javax.transaction.xa.Xid-">forget</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;id)</code>
<div class="block">Indicates that no further action will be taken on behalf of this
 transaction (after a heuristic failure).</div>
</td>
</tr>
<tr id="i10" class="altColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#getConnection-javax.security.auth.Subject-javax.resource.spi.ConnectionRequestInfo-">getConnection</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/javax/security/auth/Subject.html?is-external=true" title="class or interface in javax.security.auth">Subject</a>&nbsp;subject,
             javax.resource.spi.ConnectionRequestInfo&nbsp;cri)</code>
<div class="block">Creates a new connection handle for the underlying physical connection
 represented by the <code>ManagedConnection</code> instance.</div>
</td>
</tr>
<tr id="i11" class="rowColor">
<td class="colFirst"><code><a href="../../../org/firebirdsql/jca/FBConnectionRequestInfo.html" title="class in org.firebirdsql.jca">FBConnectionRequestInfo</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#getConnectionRequestInfo--">getConnectionRequestInfo</a></span>()</code>
<div class="block">Get information about the current connection parameters.</div>
</td>
</tr>
<tr id="i12" class="altColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#getDatabase--">getDatabase</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i13" class="rowColor">
<td class="colFirst"><code><a href="../../../org/firebirdsql/gds/impl/GDSHelper.html" title="class in org.firebirdsql.gds.impl">GDSHelper</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#getGDSHelper--">getGDSHelper</a></span>()</code>
<div class="block">Get instance of <a href="../../../org/firebirdsql/gds/impl/GDSHelper.html" title="class in org.firebirdsql.gds.impl"><code>GDSHelper</code></a> connected with this managed connection.</div>
</td>
</tr>
<tr id="i14" class="altColor">
<td class="colFirst"><code>javax.resource.spi.LocalTransaction</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#getLocalTransaction--">getLocalTransaction</a></span>()</code>
<div class="block">Returns a <code>javax.resource.spi.LocalTransaction</code> instance.</div>
</td>
</tr>
<tr id="i15" class="rowColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/8/docs/api/java/io/PrintWriter.html?is-external=true" title="class or interface in java.io">PrintWriter</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#getLogWriter--">getLogWriter</a></span>()</code>
<div class="block">Gets the log writer for this ManagedConnection instance.</div>
</td>
</tr>
<tr id="i16" class="altColor">
<td class="colFirst"><code>javax.resource.spi.ManagedConnectionFactory</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#getManagedConnectionFactory--">getManagedConnectionFactory</a></span>()</code>
<div class="block">Get the managed connection factory that created this managed connection.</div>
</td>
</tr>
<tr id="i17" class="rowColor">
<td class="colFirst"><code>javax.resource.spi.ManagedConnectionMetaData</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#getMetaData--">getMetaData</a></span>()</code>
<div class="block">Gets the metadata information for this connection's underlying EIS
 resource manager instance.</div>
</td>
</tr>
<tr id="i18" class="altColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#getSynchronizationObject--">getSynchronizationObject</a></span>()</code>
<div class="block">Get synchronization object.</div>
</td>
</tr>
<tr id="i19" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#getTransactionIsolation--">getTransactionIsolation</a></span>()</code>
<div class="block">Get the transaction isolation level of this connection.</div>
</td>
</tr>
<tr id="i20" class="altColor">
<td class="colFirst"><code><a href="../../../org/firebirdsql/gds/TransactionParameterBuffer.html" title="interface in org.firebirdsql.gds">TransactionParameterBuffer</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#getTransactionParameters--">getTransactionParameters</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i21" class="rowColor">
<td class="colFirst"><code><a href="../../../org/firebirdsql/gds/TransactionParameterBuffer.html" title="interface in org.firebirdsql.gds">TransactionParameterBuffer</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#getTransactionParameters-int-">getTransactionParameters</a></span>(int&nbsp;isolation)</code>&nbsp;</td>
</tr>
<tr id="i22" class="altColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#getTransactionTimeout--">getTransactionTimeout</a></span>()</code>
<div class="block">Gets the transaction timeout.</div>
</td>
</tr>
<tr id="i23" class="rowColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a></code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#getXAResource--">getXAResource</a></span>()</code>
<div class="block">Return an XA resource to the caller.</div>
</td>
</tr>
<tr id="i24" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#inDistributedTransaction--">inDistributedTransaction</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i25" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#internalStart-javax.transaction.xa.Xid-int-">internalStart</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;id,
             int&nbsp;flags)</code>
<div class="block">Perform the internal processing to start associate a JDBC connection with
 a global transaction.</div>
</td>
</tr>
<tr id="i26" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#inTransaction--">inTransaction</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i27" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#isConnectionSharing--">isConnectionSharing</a></span>()</code>
<div class="block">Check if connection sharing is enabled.</div>
</td>
</tr>
<tr id="i28" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#isManagedEnvironment--">isManagedEnvironment</a></span>()</code>&nbsp;</td>
</tr>
<tr id="i29" class="rowColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#isReadOnly--">isReadOnly</a></span>()</code>
<div class="block">Retrieve whether this connection is readonly.</div>
</td>
</tr>
<tr id="i30" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#isSameRM-javax.transaction.xa.XAResource-">isSameRM</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a>&nbsp;res)</code>
<div class="block">Retrieve whether this <code>FBManagedConnection</code> uses the same
 ResourceManager as <code>res</code>.</div>
</td>
</tr>
<tr id="i31" class="rowColor">
<td class="colFirst"><code>int</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#prepare-javax.transaction.xa.Xid-">prepare</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;xid)</code>
<div class="block">Prepares a transaction to commit.</div>
</td>
</tr>
<tr id="i32" class="altColor">
<td class="colFirst"><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>[]</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#recover-int-">recover</a></span>(int&nbsp;flags)</code>
<div class="block">Obtain a list of prepared transaction branches from a resource manager.</div>
</td>
</tr>
<tr id="i33" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#removeConnectionEventListener-javax.resource.spi.ConnectionEventListener-">removeConnectionEventListener</a></span>(javax.resource.spi.ConnectionEventListener&nbsp;listener)</code>
<div class="block">Remove a <code>ConnectionEventListner</code> from the listing of
 listeners that will be notified for a <code>ConnectionEvent</code>.</div>
</td>
</tr>
<tr id="i34" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#rollback-javax.transaction.xa.Xid-">rollback</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;xid)</code>
<div class="block">Rolls back the work, assuming it was done on behalf of the specified
 transaction.</div>
</td>
</tr>
<tr id="i35" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#setConnectionSharing-boolean-">setConnectionSharing</a></span>(boolean&nbsp;connectionSharing)</code>
<div class="block">Enable or disable connection sharing.</div>
</td>
</tr>
<tr id="i36" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#setLogWriter-java.io.PrintWriter-">setLogWriter</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/java/io/PrintWriter.html?is-external=true" title="class or interface in java.io">PrintWriter</a>&nbsp;out)</code>
<div class="block">Sets the log writer for this ManagedConnection instance.</div>
</td>
</tr>
<tr id="i37" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#setManagedEnvironment-boolean-">setManagedEnvironment</a></span>(boolean&nbsp;managedEnvironment)</code>&nbsp;</td>
</tr>
<tr id="i38" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#setReadOnly-boolean-">setReadOnly</a></span>(boolean&nbsp;readOnly)</code>
<div class="block">Set whether this connection is to be readonly</div>
</td>
</tr>
<tr id="i39" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#setTransactionIsolation-int-">setTransactionIsolation</a></span>(int&nbsp;isolation)</code>
<div class="block">Set the transaction level for this connection.</div>
</td>
</tr>
<tr id="i40" class="altColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#setTransactionParameters-int-org.firebirdsql.gds.TransactionParameterBuffer-">setTransactionParameters</a></span>(int&nbsp;isolation,
                        <a href="../../../org/firebirdsql/gds/TransactionParameterBuffer.html" title="interface in org.firebirdsql.gds">TransactionParameterBuffer</a>&nbsp;transactionParams)</code>&nbsp;</td>
</tr>
<tr id="i41" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#setTransactionParameters-org.firebirdsql.gds.TransactionParameterBuffer-">setTransactionParameters</a></span>(<a href="../../../org/firebirdsql/gds/TransactionParameterBuffer.html" title="interface in org.firebirdsql.gds">TransactionParameterBuffer</a>&nbsp;transactionParameters)</code>&nbsp;</td>
</tr>
<tr id="i42" class="altColor">
<td class="colFirst"><code>boolean</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#setTransactionTimeout-int-">setTransactionTimeout</a></span>(int&nbsp;timeout)</code>
<div class="block">Sets the transaction timeout.</div>
</td>
</tr>
<tr id="i43" class="rowColor">
<td class="colFirst"><code>void</code></td>
<td class="colLast"><code><span class="memberNameLink"><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#start-javax.transaction.xa.Xid-int-">start</a></span>(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;id,
     int&nbsp;flags)</code>
<div class="block">Associates a JDBC connection with a global transaction.</div>
</td>
</tr>
</table>
<ul class="blockList">
<li class="blockList"><a name="methods.inherited.from.class.java.lang.Object">
<!--   -->
</a>
<h3>Methods inherited from class&nbsp;java.lang.<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a></h3>
<code><a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#clone--" title="class or interface in java.lang">clone</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#equals-java.lang.Object-" title="class or interface in java.lang">equals</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#finalize--" title="class or interface in java.lang">finalize</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#getClass--" title="class or interface in java.lang">getClass</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#hashCode--" title="class or interface in java.lang">hashCode</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notify--" title="class or interface in java.lang">notify</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#notifyAll--" title="class or interface in java.lang">notifyAll</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#toString--" title="class or interface in java.lang">toString</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait--" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-" title="class or interface in java.lang">wait</a>, <a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true#wait-long-int-" title="class or interface in java.lang">wait</a></code></li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
<div class="details">
<ul class="blockList">
<li class="blockList">
<!-- ============ FIELD DETAIL =========== -->
<ul class="blockList">
<li class="blockList"><a name="field.detail">
<!--   -->
</a>
<h3>Field Detail</h3>
<a name="WARNING_NO_CHARSET">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>WARNING_NO_CHARSET</h4>
<pre>public static final&nbsp;<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a> WARNING_NO_CHARSET</pre>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../constant-values.html#org.firebirdsql.jca.FBManagedConnection.WARNING_NO_CHARSET">Constant Field Values</a></dd>
</dl>
</li>
</ul>
<a name="ERROR_NO_CHARSET">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>ERROR_NO_CHARSET</h4>
<pre>public static final&nbsp;<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a> ERROR_NO_CHARSET</pre>
<dl>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../constant-values.html#org.firebirdsql.jca.FBManagedConnection.ERROR_NO_CHARSET">Constant Field Values</a></dd>
</dl>
</li>
</ul>
</li>
</ul>
<!-- ============ METHOD DETAIL ========== -->
<ul class="blockList">
<li class="blockList"><a name="method.detail">
<!--   -->
</a>
<h3>Method Detail</h3>
<a name="errorOccurred-java.lang.Object-java.sql.SQLException-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>errorOccurred</h4>
<pre>public&nbsp;void&nbsp;errorOccurred(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;source,
                          <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a>&nbsp;ex)</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../org/firebirdsql/gds/ng/listeners/ExceptionListener.html#errorOccurred-java.lang.Object-java.sql.SQLException-">ExceptionListener</a></code></span></div>
<div class="block">Notify about a SQLException</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../org/firebirdsql/gds/ng/listeners/ExceptionListener.html#errorOccurred-java.lang.Object-java.sql.SQLException-">errorOccurred</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/firebirdsql/gds/ng/listeners/ExceptionListener.html" title="interface in org.firebirdsql.gds.ng.listeners">ExceptionListener</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>source</code> - The source of the event; note for caller: this should be the object this listener is registered at.</dd>
<dd><code>ex</code> - error that occurred.</dd>
</dl>
</li>
</ul>
<a name="getGDSHelper--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getGDSHelper</h4>
<pre>public&nbsp;<a href="../../../org/firebirdsql/gds/impl/GDSHelper.html" title="class in org.firebirdsql.gds.impl">GDSHelper</a>&nbsp;getGDSHelper()
                       throws <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Get instance of <a href="../../../org/firebirdsql/gds/impl/GDSHelper.html" title="class in org.firebirdsql.gds.impl"><code>GDSHelper</code></a> connected with this managed connection.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>instance of <a href="../../../org/firebirdsql/gds/impl/GDSHelper.html" title="class in org.firebirdsql.gds.impl"><code>GDSHelper</code></a>.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code> - If this connection has no GDSHelper</dd>
</dl>
</li>
</ul>
<a name="getDatabase--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getDatabase</h4>
<pre>public&nbsp;<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/String.html?is-external=true" title="class or interface in java.lang">String</a>&nbsp;getDatabase()</pre>
</li>
</ul>
<a name="isManagedEnvironment--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isManagedEnvironment</h4>
<pre>public&nbsp;boolean&nbsp;isManagedEnvironment()</pre>
</li>
</ul>
<a name="inTransaction--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>inTransaction</h4>
<pre>public&nbsp;boolean&nbsp;inTransaction()</pre>
</li>
</ul>
<a name="setManagedEnvironment-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setManagedEnvironment</h4>
<pre>public&nbsp;void&nbsp;setManagedEnvironment(boolean&nbsp;managedEnvironment)
                           throws javax.resource.ResourceException</pre>
<dl>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>javax.resource.ResourceException</code></dd>
</dl>
</li>
</ul>
<a name="isConnectionSharing--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isConnectionSharing</h4>
<pre>public&nbsp;boolean&nbsp;isConnectionSharing()</pre>
<div class="block">Check if connection sharing is enabled. When connection sharing is 
 enabled, multiple connection handles (<a href="../../../org/firebirdsql/jdbc/FBConnection.html" title="class in org.firebirdsql.jdbc"><code>FBConnection</code></a> instances)
 can access this managed connection in thread-safe manner (they synchronize
 on this instance). This feature can be enabled only in JCA environment,
 any other environment must not use connection sharing.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><code>true</code> if connection sharing is enabled.</dd>
</dl>
</li>
</ul>
<a name="setConnectionSharing-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setConnectionSharing</h4>
<pre>public&nbsp;void&nbsp;setConnectionSharing(boolean&nbsp;connectionSharing)
                          throws javax.resource.ResourceException</pre>
<div class="block">Enable or disable connection sharing. See <a href="../../../org/firebirdsql/jca/FBManagedConnection.html#isConnectionSharing--"><code>isConnectionSharing()</code></a>
 method for details.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>connectionSharing</code> - <code>true</code> if connection sharing must be
 enabled.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>javax.resource.ResourceException</code> - If connection sharing state cannot be changed</dd>
</dl>
</li>
</ul>
<a name="getLocalTransaction--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getLocalTransaction</h4>
<pre>public&nbsp;javax.resource.spi.LocalTransaction&nbsp;getLocalTransaction()</pre>
<div class="block">Returns a <code>javax.resource.spi.LocalTransaction</code> instance.
 The LocalTransaction interface is used by the container to manage local
 transactions for a RM instance.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code>getLocalTransaction</code>&nbsp;in interface&nbsp;<code>javax.resource.spi.ManagedConnection</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>LocalTransaction instance</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>javax.resource.ResourceException</code> - generic exception if operation fails</dd>
<dd><code>javax.resource.NotSupportedException</code> - if the operation is not supported</dd>
<dd><code>javax.resource.spi.ResourceAdapterInternalException</code> - resource adapter internal error condition</dd>
</dl>
</li>
</ul>
<a name="getMetaData--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getMetaData</h4>
<pre>public&nbsp;javax.resource.spi.ManagedConnectionMetaData&nbsp;getMetaData()
                                                         throws javax.resource.ResourceException</pre>
<div class="block">Gets the metadata information for this connection's underlying EIS
 resource manager instance. The ManagedConnectionMetaData interface
 provides information about the underlying EIS instance associated with
 the ManagedConenction instance.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code>getMetaData</code>&nbsp;in interface&nbsp;<code>javax.resource.spi.ManagedConnection</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>ManagedConnectionMetaData instance</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>javax.resource.ResourceException</code> - generic exception if operation fails</dd>
<dd><code>javax.resource.NotSupportedException</code> - if the operation is not supported</dd>
</dl>
</li>
</ul>
<a name="setLogWriter-java.io.PrintWriter-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setLogWriter</h4>
<pre>public&nbsp;void&nbsp;setLogWriter(<a href="https://docs.oracle.com/javase/8/docs/api/java/io/PrintWriter.html?is-external=true" title="class or interface in java.io">PrintWriter</a>&nbsp;out)</pre>
<div class="block">Sets the log writer for this ManagedConnection instance.
 <P>
 The log writer is a character output stream to which all logging and
 tracing messages for this ManagedConnection instance will be printed.
 Application Server manages the association of output stream with the
 ManagedConnection instance based on the connection pooling requirements.
 <P>
 When a ManagedConnection object is initially created, the default log
 writer associated with this instance is obtained from the
 <code>ManagedConnectionFactory</code>. An application server can set a
 log writer specific to this ManagedConnection to log/trace this instance
 using setLogWriter method.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code>setLogWriter</code>&nbsp;in interface&nbsp;<code>javax.resource.spi.ManagedConnection</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>out</code> - Character Output stream to be associated</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>javax.resource.ResourceException</code> - generic exception if operation fails</dd>
<dd><code>javax.resource.spi.ResourceAdapterInternalException</code> - resource adapter related error condition</dd>
</dl>
</li>
</ul>
<a name="getLogWriter--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getLogWriter</h4>
<pre>public&nbsp;<a href="https://docs.oracle.com/javase/8/docs/api/java/io/PrintWriter.html?is-external=true" title="class or interface in java.io">PrintWriter</a>&nbsp;getLogWriter()</pre>
<div class="block">Gets the log writer for this ManagedConnection instance.
 <P>
 The log writer is a character output stream to which all logging and
 tracing messages for this ManagedConnection instance will be printed.
 <code>ConnectionManager</code> manages the association of output stream
 with the <code>ManagedConnection</code> instance based on the
 connection pooling requirements.
 <P>
 The Log writer associated with a <code>ManagedConnection</code>
 instance can be one set as default from the ManagedConnectionFactory
 (that created this connection) or one set specifically for this instance
 by the application server.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code>getLogWriter</code>&nbsp;in interface&nbsp;<code>javax.resource.spi.ManagedConnection</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Character ourput stream associated with this
         <code>ManagedConnection</code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>javax.resource.ResourceException</code> - generic exception if operation fails</dd>
</dl>
</li>
</ul>
<a name="addConnectionEventListener-javax.resource.spi.ConnectionEventListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>addConnectionEventListener</h4>
<pre>public&nbsp;void&nbsp;addConnectionEventListener(javax.resource.spi.ConnectionEventListener&nbsp;listener)</pre>
<div class="block">Add an <code>ConnectionEventListener</code> listener. The listener will
 be notified when a <code>ConnectionEvent</code> occurs.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code>addConnectionEventListener</code>&nbsp;in interface&nbsp;<code>javax.resource.spi.ManagedConnection</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>listener</code> - The <code>ConnectionEventListener</code> to be added</dd>
</dl>
</li>
</ul>
<a name="removeConnectionEventListener-javax.resource.spi.ConnectionEventListener-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>removeConnectionEventListener</h4>
<pre>public&nbsp;void&nbsp;removeConnectionEventListener(javax.resource.spi.ConnectionEventListener&nbsp;listener)</pre>
<div class="block">Remove a <code>ConnectionEventListner</code> from the listing of
 listeners that will be notified for a <code>ConnectionEvent</code>.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code>removeConnectionEventListener</code>&nbsp;in interface&nbsp;<code>javax.resource.spi.ManagedConnection</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>listener</code> - The <code>ConnectionEventListener</code> to be removed</dd>
</dl>
</li>
</ul>
<a name="associateConnection-java.lang.Object-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>associateConnection</h4>
<pre>public&nbsp;void&nbsp;associateConnection(<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;connection)
                         throws javax.resource.ResourceException</pre>
<div class="block">Used by the container to change the association of an application-level
 connection handle with a ManagedConneciton instance. The container should
 find the right ManagedConnection instance and call the
 associateConnection method.
 <P>
 The resource adapter is required to implement the associateConnection
 method. The method implementation for a ManagedConnection should
 dissociate the connection handle (passed as a parameter) from its
 currently associated ManagedConnection and associate the new connection
 handle with itself.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code>associateConnection</code>&nbsp;in interface&nbsp;<code>javax.resource.spi.ManagedConnection</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>connection</code> - Application-level connection handle</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>javax.resource.ResourceException</code> - Failed to associate the connection handle with this
             ManagedConnection instance</dd>
<dd><code>javax.resource.spi.IllegalStateException</code> - Illegal state for invoking this method</dd>
<dd><code>javax.resource.spi.ResourceAdapterInternalException</code> - Resource adapter internal error condition</dd>
</dl>
</li>
</ul>
<a name="cleanup--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>cleanup</h4>
<pre>public&nbsp;void&nbsp;cleanup()
             throws javax.resource.ResourceException</pre>
<div class="block">Application server calls this method to force any cleanup on the
 <code>ManagedConnection</code> instance.
 <P>
 The method <code>ManagedConnection.cleanup()</code>initiates a cleanup of the
 any client-specific state as maintained by a ManagedConnection instance.
 The cleanup should invalidate all connection handles that had been
 created using this <code>ManagedConnection</code> instance. Any attempt
 by an application component to use the connection handle after cleanup of
 the underlying <code>ManagedConnection</code> should result in an
 exception.
 <P>
 The cleanup of ManagedConnection is always driven by an application
 server. An application server should not invoke
 <code>ManagedConnection.cleanup()</code>when there is an uncompleted
 transaction (associated with a ManagedConnection instance) in progress.
 <P>
 The invocation of <code>ManagedConnection.cleanup()</code>method on an already
 cleaned-up connection should not throw an exception.
 
 The cleanup of <code>ManagedConnection</code> instance resets its
 client specific state and prepares the connection to be put back in to a
 connection pool. The cleanup method should not cause resource adapter to
 close the physical pipe and reclaim system resources associated with the
 physical connection.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code>cleanup</code>&nbsp;in interface&nbsp;<code>javax.resource.spi.ManagedConnection</code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>javax.resource.ResourceException</code> - generic exception if operation fails</dd>
<dd><code>javax.resource.spi.ResourceAdapterInternalException</code> - resource adapter internal error condition</dd>
<dd><code>javax.resource.spi.IllegalStateException</code> - Illegal state for calling connection cleanup. Example - if a
             local transaction is in progress that doesn't allow
             connection cleanup</dd>
</dl>
</li>
</ul>
<a name="getConnection-javax.security.auth.Subject-javax.resource.spi.ConnectionRequestInfo-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getConnection</h4>
<pre>public&nbsp;<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;getConnection(<a href="https://docs.oracle.com/javase/8/docs/api/javax/security/auth/Subject.html?is-external=true" title="class or interface in javax.security.auth">Subject</a>&nbsp;subject,
                            javax.resource.spi.ConnectionRequestInfo&nbsp;cri)
                     throws javax.resource.ResourceException</pre>
<div class="block">Creates a new connection handle for the underlying physical connection
 represented by the <code>ManagedConnection</code> instance. This
 connection handle is used by the application code to refer to the
 underlying physical connection. A connection handle is tied to its
 <code>ManagedConnection</code> instance in a resource adapter
 implementation specific way.
 <P>
 
 The <code>ManagedConnection</code> uses the Subject and additional
 <code>ConnectionRequestInfo</code> (which is specific to resource
 adapter and opaque to application server) to set the state of the
 physical connection.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code>getConnection</code>&nbsp;in interface&nbsp;<code>javax.resource.spi.ManagedConnection</code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>subject</code> - security context as JAAS subject</dd>
<dd><code>cri</code> - ConnectionRequestInfo instance</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>generic <code>Object</code> instance representing the
         connection handle. For CCI, the connection handle created by a
         <code>ManagedConnection</code> instance is of the type
         <code>javax.resource.cci.Connection</code>.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>javax.resource.ResourceException</code> - generic exception if operation fails</dd>
<dd><code>javax.resource.spi.ResourceAdapterInternalException</code> - resource adapter internal error condition</dd>
<dd><code>javax.resource.spi.SecurityException</code> - security related error condition</dd>
<dd><code>javax.resource.spi.CommException</code> - failed communication with EIS instance</dd>
<dd><code>javax.resource.spi.EISSystemException</code> - internal error condition in EIS instance - used if EIS
             instance is involved in setting state of
             <code>ManagedConnection</code></dd>
</dl>
</li>
</ul>
<a name="destroy--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>destroy</h4>
<pre>public&nbsp;void&nbsp;destroy()
             throws javax.resource.ResourceException</pre>
<div class="block">Destroys the physical connection to the underlying resource manager. To
 manage the size of the connection pool, an application server can
 explictly call <code>ManagedConnection.destroy()</code>to destroy a physical
 connection. A resource adapter should destroy all allocated system
 resources for this <code>ManagedConnection</code> instance when the
 method destroy is called.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code>destroy</code>&nbsp;in interface&nbsp;<code>javax.resource.spi.ManagedConnection</code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>javax.resource.ResourceException</code> - generic exception if operation failed</dd>
<dd><code>javax.resource.spi.IllegalStateException</code> - illegal state for destroying connection</dd>
</dl>
</li>
</ul>
<a name="getXAResource--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getXAResource</h4>
<pre>public&nbsp;<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a>&nbsp;getXAResource()</pre>
<div class="block">Return an XA resource to the caller.
 <P>
 In both <code>javax.sql.XAConnection</code> and
 <code>javax.resource.spi.MangagedConnection</code>.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code>getXAResource</code>&nbsp;in interface&nbsp;<code>javax.resource.spi.ManagedConnection</code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>the XAResource</dd>
</dl>
</li>
</ul>
<a name="commit-javax.transaction.xa.Xid-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>commit</h4>
<pre>public&nbsp;void&nbsp;commit(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;id,
                   boolean&nbsp;onePhase)
            throws <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></pre>
<div class="block">Commits a transaction.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#commit-javax.transaction.xa.Xid-boolean-" title="class or interface in javax.transaction.xa">commit</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></code> - Occurs when the state was not correct (end never called), the
             transaction ID is wrong, the connection was set to
             Auto-Commit, or the commit on the underlying connection
             fails. The error code differs depending on the exact
             situation.</dd>
</dl>
</li>
</ul>
<a name="end-javax.transaction.xa.Xid-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>end</h4>
<pre>public&nbsp;void&nbsp;end(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;id,
                int&nbsp;flags)
         throws <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></pre>
<div class="block">Dissociates a resource from a global transaction.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#end-javax.transaction.xa.Xid-int-" title="class or interface in javax.transaction.xa">end</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></code> - Occurs when the state was not correct (end called twice), or
             the transaction ID is wrong.</dd>
</dl>
</li>
</ul>
<a name="forget-javax.transaction.xa.Xid-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>forget</h4>
<pre>public&nbsp;void&nbsp;forget(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;id)
            throws <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></pre>
<div class="block">Indicates that no further action will be taken on behalf of this
 transaction (after a heuristic failure). It is assumed this will be
 called after a failed commit or rollback.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#forget-javax.transaction.xa.Xid-" title="class or interface in javax.transaction.xa">forget</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></code> - Occurs when the state was not correct (end never called), or
             the transaction ID is wrong.</dd>
</dl>
</li>
</ul>
<a name="getTransactionTimeout--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTransactionTimeout</h4>
<pre>public&nbsp;int&nbsp;getTransactionTimeout()
                          throws <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></pre>
<div class="block">Gets the transaction timeout.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#getTransactionTimeout--" title="class or interface in javax.transaction.xa">getTransactionTimeout</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></code></dd>
</dl>
</li>
</ul>
<a name="isSameRM-javax.transaction.xa.XAResource-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>isSameRM</h4>
<pre>public&nbsp;boolean&nbsp;isSameRM(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a>&nbsp;res)
                 throws <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></pre>
<div class="block">Retrieve whether this <code>FBManagedConnection</code> uses the same
 ResourceManager as <code>res</code>. This method relies on
 <code>res</code> being a Firebird implementation of
 <code>XAResource</code>.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#isSameRM-javax.transaction.xa.XAResource-" title="class or interface in javax.transaction.xa">isSameRM</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>res</code> - The other <code>XAResource</code> to compare to</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><code>true</code> if <code>res</code> uses the same
         ResourceManager, <code>false</code> otherwise</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></code></dd>
</dl>
</li>
</ul>
<a name="prepare-javax.transaction.xa.Xid-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>prepare</h4>
<pre>public&nbsp;int&nbsp;prepare(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;xid)
            throws <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></pre>
<div class="block">Prepares a transaction to commit.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#prepare-javax.transaction.xa.Xid-" title="class or interface in javax.transaction.xa">prepare</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></code> - Occurs when the state was not correct (end never called), the
             transaction ID is wrong, or the connection was set to
             Auto-Commit.</dd>
</dl>
</li>
</ul>
<a name="recover-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>recover</h4>
<pre>public&nbsp;<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>[]&nbsp;recover(int&nbsp;flags)
              throws <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></pre>
<div class="block">Obtain a list of prepared transaction branches from a resource manager.
 The transaction manager calls this method during recovery to obtain the
 list of transaction branches that are currently in prepared or
 heuristically completed states.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#recover-int-" title="class or interface in javax.transaction.xa">recover</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>flags</code> - One of TMSTARTRSCAN, TMENDRSCAN, TMNOFLAGS. TMNOFLAGS must be
            used when no other flags are set in flags.</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The resource manager returns zero or more XIDs for the
         transaction branches that are currently in a prepared or
         heuristically completed state. If an error occurs during the
         operation, the resource manager should throw the appropriate
         XAException.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></code> - An error has occurred. Possible values are XAER_RMERR,
             XAER_RMFAIL, XAER_INVAL, and XAER_PROTO.</dd>
</dl>
</li>
</ul>
<a name="findSingleXid-javax.transaction.xa.Xid-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>findSingleXid</h4>
<pre>protected&nbsp;<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;findSingleXid(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;externalXid)
                     throws <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></pre>
<div class="block">Obtain a single prepared transaction branch from a resource manager, based on a Xid</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>externalXid</code> - The Xid to find</dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>The Xid if found, otherwise null.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></code> - An error has occurred. Possible values are XAER_RMERR,
             XAER_RMFAIL, XAER_INVAL, and XAER_PROTO.</dd>
</dl>
</li>
</ul>
<a name="getSynchronizationObject--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getSynchronizationObject</h4>
<pre>public final&nbsp;<a href="https://docs.oracle.com/javase/8/docs/api/java/lang/Object.html?is-external=true" title="class or interface in java.lang">Object</a>&nbsp;getSynchronizationObject()</pre>
<div class="block"><span class="descfrmTypeLabel">Description copied from interface:&nbsp;<code><a href="../../../org/firebirdsql/jdbc/Synchronizable.html#getSynchronizationObject--">Synchronizable</a></code></span></div>
<div class="block">Get synchronization object.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="../../../org/firebirdsql/jdbc/Synchronizable.html#getSynchronizationObject--">getSynchronizationObject</a></code>&nbsp;in interface&nbsp;<code><a href="../../../org/firebirdsql/jdbc/Synchronizable.html" title="interface in org.firebirdsql.jdbc">Synchronizable</a></code></dd>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>object, cannot be <code>null</code>.</dd>
</dl>
</li>
</ul>
<a name="rollback-javax.transaction.xa.Xid-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>rollback</h4>
<pre>public&nbsp;void&nbsp;rollback(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;xid)
              throws <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></pre>
<div class="block">Rolls back the work, assuming it was done on behalf of the specified
 transaction.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#rollback-javax.transaction.xa.Xid-" title="class or interface in javax.transaction.xa">rollback</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a></code></dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></code> - Occurs when the state was not correct (end never called), the
             transaction ID is wrong, the connection was set to
             Auto-Commit, or the rollback on the underlying connection
             fails. The error code differs depending on the exact
             situation.</dd>
</dl>
</li>
</ul>
<a name="setTransactionTimeout-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setTransactionTimeout</h4>
<pre>public&nbsp;boolean&nbsp;setTransactionTimeout(int&nbsp;timeout)
                              throws <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></pre>
<div class="block">Sets the transaction timeout. This is saved, but the value is not used by
 the current implementation.</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#setTransactionTimeout-int-" title="class or interface in javax.transaction.xa">setTransactionTimeout</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>timeout</code> - The timeout to be set in seconds</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></code></dd>
</dl>
</li>
</ul>
<a name="inDistributedTransaction--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>inDistributedTransaction</h4>
<pre>public&nbsp;boolean&nbsp;inDistributedTransaction()</pre>
</li>
</ul>
<a name="start-javax.transaction.xa.Xid-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>start</h4>
<pre>public&nbsp;void&nbsp;start(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;id,
                  int&nbsp;flags)
           throws <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></pre>
<div class="block">Associates a JDBC connection with a global transaction. We assume that
 end will be called followed by prepare, commit, or rollback. If start is
 called after end but before commit or rollback, there is no way to
 distinguish work done by different transactions on the same connection).
 If start is called more than once before end, either it's a duplicate
 transaction ID or illegal transaction ID (since you can't have two
 transactions associated with one DB connection).</div>
<dl>
<dt><span class="overrideSpecifyLabel">Specified by:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true#start-javax.transaction.xa.Xid-int-" title="class or interface in javax.transaction.xa">start</a></code>&nbsp;in interface&nbsp;<code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAResource.html?is-external=true" title="class or interface in javax.transaction.xa">XAResource</a></code></dd>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>id</code> - A global transaction identifier to be associated with the
            resource</dd>
<dd><code>flags</code> - One of TMNOFLAGS, TMJOIN, or TMRESUME</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></code> - Occurs when the state was not correct (start called twice),
             the transaction ID is wrong, or the instance has already been
             closed.</dd>
</dl>
</li>
</ul>
<a name="internalStart-javax.transaction.xa.Xid-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>internalStart</h4>
<pre>public&nbsp;void&nbsp;internalStart(<a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/Xid.html?is-external=true" title="class or interface in javax.transaction.xa">Xid</a>&nbsp;id,
                          int&nbsp;flags)
                   throws <a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a>,
                          <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></pre>
<div class="block">Perform the internal processing to start associate a JDBC connection with
 a global transaction.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>id</code> - A global transaction identifier to be associated with the
            resource</dd>
<dd><code>flags</code> - One of TMNOFLAGS, TMJOIN, or TMRESUME</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/javax/transaction/xa/XAException.html?is-external=true" title="class or interface in javax.transaction.xa">XAException</a></code> - If the transaction is already started, or this connection cannot participate in the distributed transaction</dd>
<dd><code><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/SQLException.html?is-external=true" title="class or interface in java.sql">SQLException</a></code></dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="../../../org/firebirdsql/jca/FBManagedConnection.html#start-javax.transaction.xa.Xid-int-"><code>start(Xid, int)</code></a></dd>
</dl>
</li>
</ul>
<a name="close-org.firebirdsql.jdbc.FBConnection-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>close</h4>
<pre>public&nbsp;void&nbsp;close(<a href="../../../org/firebirdsql/jdbc/FBConnection.html" title="class in org.firebirdsql.jdbc">FBConnection</a>&nbsp;c)</pre>
<div class="block">Close this connection with regards to a wrapping
 <code>AbstractConnection</code>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>c</code> - The <code>AbstractConnection</code> that is being closed</dd>
</dl>
</li>
</ul>
<a name="getConnectionRequestInfo--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getConnectionRequestInfo</h4>
<pre>public&nbsp;<a href="../../../org/firebirdsql/jca/FBConnectionRequestInfo.html" title="class in org.firebirdsql.jca">FBConnectionRequestInfo</a>&nbsp;getConnectionRequestInfo()</pre>
<div class="block">Get information about the current connection parameters.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>instance of <a href="../../../org/firebirdsql/jca/FBConnectionRequestInfo.html" title="class in org.firebirdsql.jca"><code>FBConnectionRequestInfo</code></a>.</dd>
</dl>
</li>
</ul>
<a name="getTransactionParameters--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTransactionParameters</h4>
<pre>public&nbsp;<a href="../../../org/firebirdsql/gds/TransactionParameterBuffer.html" title="interface in org.firebirdsql.gds">TransactionParameterBuffer</a>&nbsp;getTransactionParameters()</pre>
</li>
</ul>
<a name="setTransactionParameters-org.firebirdsql.gds.TransactionParameterBuffer-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setTransactionParameters</h4>
<pre>public&nbsp;void&nbsp;setTransactionParameters(<a href="../../../org/firebirdsql/gds/TransactionParameterBuffer.html" title="interface in org.firebirdsql.gds">TransactionParameterBuffer</a>&nbsp;transactionParameters)</pre>
</li>
</ul>
<a name="getTransactionParameters-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTransactionParameters</h4>
<pre>public&nbsp;<a href="../../../org/firebirdsql/gds/TransactionParameterBuffer.html" title="interface in org.firebirdsql.gds">TransactionParameterBuffer</a>&nbsp;getTransactionParameters(int&nbsp;isolation)</pre>
</li>
</ul>
<a name="setTransactionParameters-int-org.firebirdsql.gds.TransactionParameterBuffer-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setTransactionParameters</h4>
<pre>public&nbsp;void&nbsp;setTransactionParameters(int&nbsp;isolation,
                                     <a href="../../../org/firebirdsql/gds/TransactionParameterBuffer.html" title="interface in org.firebirdsql.gds">TransactionParameterBuffer</a>&nbsp;transactionParams)</pre>
</li>
</ul>
<a name="getTransactionIsolation--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getTransactionIsolation</h4>
<pre>public&nbsp;int&nbsp;getTransactionIsolation()
                            throws javax.resource.ResourceException</pre>
<div class="block">Get the transaction isolation level of this connection. The level is one
 of the static final fields of <code>java.sql.Connection</code> (i.e.
 <code>TRANSACTION_READ_COMMITTED</code>,
 <code>TRANSACTION_READ_UNCOMMITTED</code>,
 <code>TRANSACTION_REPEATABLE_READ</code>,
 <code>TRANSACTION_SERIALIZABLE</code>.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>Value representing a transaction isolation level defined in
         <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/Connection.html?is-external=true" title="class or interface in java.sql"><code>Connection</code></a>.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>javax.resource.ResourceException</code> - If the transaction level cannot be retrieved</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/Connection.html?is-external=true" title="class or interface in java.sql"><code>Connection</code></a>, 
<a href="../../../org/firebirdsql/jca/FBManagedConnection.html#setTransactionIsolation-int-"><code>setTransactionIsolation(int)</code></a></dd>
</dl>
</li>
</ul>
<a name="setTransactionIsolation-int-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setTransactionIsolation</h4>
<pre>public&nbsp;void&nbsp;setTransactionIsolation(int&nbsp;isolation)
                             throws javax.resource.ResourceException</pre>
<div class="block">Set the transaction level for this connection. The level is one of the
 static final fields of <code>java.sql.Connection</code> (i.e.
 <code>TRANSACTION_READ_COMMITTED</code>,
 <code>TRANSACTION_READ_UNCOMMITTED</code>,
 <code>TRANSACTION_REPEATABLE_READ</code>,
 <code>TRANSACTION_SERIALIZABLE</code>.</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>isolation</code> - Value representing a transaction isolation level defined in
            <a href="https://docs.oracle.com/javase/8/docs/api/java/sql/Connection.html?is-external=true" title="class or interface in java.sql"><code>Connection</code></a>.</dd>
<dt><span class="throwsLabel">Throws:</span></dt>
<dd><code>javax.resource.ResourceException</code> - If the transaction level cannot be retrieved</dd>
<dt><span class="seeLabel">See Also:</span></dt>
<dd><a href="https://docs.oracle.com/javase/8/docs/api/java/sql/Connection.html?is-external=true" title="class or interface in java.sql"><code>Connection</code></a>, 
<a href="../../../org/firebirdsql/jca/FBManagedConnection.html#getTransactionIsolation--"><code>getTransactionIsolation()</code></a></dd>
</dl>
</li>
</ul>
<a name="getManagedConnectionFactory--">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>getManagedConnectionFactory</h4>
<pre>public&nbsp;javax.resource.spi.ManagedConnectionFactory&nbsp;getManagedConnectionFactory()</pre>
<div class="block">Get the managed connection factory that created this managed connection.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd>instance of <code>ManagedConnectionFactory</code>.</dd>
</dl>
</li>
</ul>
<a name="setReadOnly-boolean-">
<!--   -->
</a>
<ul class="blockList">
<li class="blockList">
<h4>setReadOnly</h4>
<pre>public&nbsp;void&nbsp;setReadOnly(boolean&nbsp;readOnly)</pre>
<div class="block">Set whether this connection is to be readonly</div>
<dl>
<dt><span class="paramLabel">Parameters:</span></dt>
<dd><code>readOnly</code> - If <code>true</code>, the connection will be set read-only,
            otherwise it will be writable</dd>
</dl>
</li>
</ul>
<a name="isReadOnly--">
<!--   -->
</a>
<ul class="blockListLast">
<li class="blockList">
<h4>isReadOnly</h4>
<pre>public&nbsp;boolean&nbsp;isReadOnly()</pre>
<div class="block">Retrieve whether this connection is readonly.</div>
<dl>
<dt><span class="returnLabel">Returns:</span></dt>
<dd><code>true</code> if this connection is readonly,
         <code>false</code> otherwise</dd>
</dl>
</li>
</ul>
</li>
</ul>
</li>
</ul>
</div>
</div>
<!-- ========= END OF CLASS DATA ========= -->
<!-- ======= START OF BOTTOM NAVBAR ====== -->
<div class="bottomNav"><a name="navbar.bottom">
<!--   -->
</a>
<div class="skipNav"><a href="#skip.navbar.bottom" title="Skip navigation links">Skip navigation links</a></div>
<a name="navbar.bottom.firstrow">
<!--   -->
</a>
<ul class="navList" title="Navigation">
<li><a href="../../../overview-summary.html">Overview</a></li>
<li><a href="package-summary.html">Package</a></li>
<li class="navBarCell1Rev">Class</li>
<li><a href="package-tree.html">Tree</a></li>
<li><a href="../../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../../index-all.html">Index</a></li>
<li><a href="../../../help-doc.html">Help</a></li>
</ul>
</div>
<div class="subNav">
<ul class="navList">
<li><a href="../../../org/firebirdsql/jca/FBLocalTransaction.FBLocalXid.html" title="class in org.firebirdsql.jca"><span class="typeNameLink">Prev&nbsp;Class</span></a></li>
<li><a href="../../../org/firebirdsql/jca/FBManagedConnectionFactory.html" title="class in org.firebirdsql.jca"><span class="typeNameLink">Next&nbsp;Class</span></a></li>
</ul>
<ul class="navList">
<li><a href="../../../index.html?org/firebirdsql/jca/FBManagedConnection.html" target="_top">Frames</a></li>
<li><a href="FBManagedConnection.html" target="_top">No&nbsp;Frames</a></li>
</ul>
<ul class="navList" id="allclasses_navbar_bottom">
<li><a href="../../../allclasses-noframe.html">All&nbsp;Classes</a></li>
</ul>
<div>
<script type="text/javascript"><!--
  allClassesLink = document.getElementById("allclasses_navbar_bottom");
  if(window==top) {
    allClassesLink.style.display = "block";
  }
  else {
    allClassesLink.style.display = "none";
  }
  //-->
</script>
</div>
<div>
<ul class="subNavList">
<li>Summary:&nbsp;</li>
<li>Nested&nbsp;|&nbsp;</li>
<li><a href="#field.summary">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.summary">Method</a></li>
</ul>
<ul class="subNavList">
<li>Detail:&nbsp;</li>
<li><a href="#field.detail">Field</a>&nbsp;|&nbsp;</li>
<li>Constr&nbsp;|&nbsp;</li>
<li><a href="#method.detail">Method</a></li>
</ul>
</div>
<a name="skip.navbar.bottom">
<!--   -->
</a></div>
<!-- ======== END OF BOTTOM NAVBAR ======= -->
<p class="legalCopy"><small>Copyright &copy; 2001-2019 Jaybird (Firebird JDBC/JCA) team. All rights reserved.</small></p>
</body>
</html>
